<script>

  import { beforeUpdate, onMount, onDestroy } from 'svelte';

  export let setApp   = null;
  export let number   = '';
  export let contacts = [];

  export let from = null;

  let contactLabel = null;
  let audio        = null;

  function acceptCall() {
    window.parent.postMessage(JSON.stringify({action: 'accept_call', number, target: from}))
    setApp('call', {target: from});
  }

  function denyCall() {
    window.parent.postMessage(JSON.stringify({action: 'deny_call', number, target: from}))
    setApp(null);
  }


  beforeUpdate(() => {

    const contact = contacts.find(e => e.number === from);

    if(contact)
      contactLabel = contact.name;
    else
      contactLabel = '#' + from;

  });

  onMount(() => {

    if(audio !== null)
      audio.pause();

    audio          = new Audio('./audio/incoming-call.mp3');
    audio.loop     = true;
    audio.autoplay = true;
    audio.volume   = 0.25;

  });

  onDestroy(() => {
    audio.pause();
  })

</script>

<style>

  .app-incomingcall {
    width: calc(100% - 16px);
    height: 100%;
    user-select: none;
  }

  .contact-label {
    position: absolute;
    left: 50%;
    top: 20%;
    transform: translate(-50%, -50%);
    font-weight: bold;
    font-size: 2em;
    color: #FFF;
  }

  .circle-light {
    position: absolute;
    margin-left: 50%;
    transform: translate(-50%, -50%) scale(0.75);
    font-size: 2.0em;
    color: #005AFF;
  }

  .circle-light:nth-child(1) {
    top: 40%;
    animation: circle-light-1 1s infinite, circle-light-reverse-1 1s infinite;
  }

  .circle-light:nth-child(2) {
    top: 50%;
    animation: circle-light-2 1s infinite, circle-light-reverse-2 1s infinite;
  }

  .circle-light:nth-child(3) {
    top: 60%;
    animation: circle-light-3 1s infinite, circle-light-reverse-3 1s infinite;
  }

  .call-button {
    position: absolute;
    left: 50%;
    top: 80%;
    transform: translate(-50%, -50%);
    width: 56px;
    height: 56px;
    display: flex;
    flex-direction: row;
    align-items: center;
    justify-content: center;
    color: #FFF;
    border-radius: 50%;
  }

  .call-button:hover {
    border: 2px solid #FFF;
  }

  .end-call {
    background-color: #a92c2c;
    left: 30%;
  }

  .accept-call {
    background-color: rgb(77, 152, 74);
    left: 70%;
  }

  @keyframes circle-light-1 {
    0%   { color: #B4CEFF; font-size: 1em}
    25%  { color: #FFFFFF; font-size: 1.25em}
    50%  { color: #005AFF; font-size: 1.5em}
    75%  { color: #3079FF; font-size: 1.75em}
    100% { color: #6A9FFF; font-size: 2em}
  }

  @keyframes circle-light-reverse-1 {
    0%   { color: #6A9FFF; font-size: 2em}
    25%  { color: #3079FF; font-size: 1.75em}
    50%  { color: #005AFF; font-size: 1.5em}
    75%  { color: #FFFFFF; font-size: 1.25em}
    100% { color: #B4CEFF; font-size: 1em}
  }

  @keyframes circle-light-2 {
    0%   { color: #3079FF; font-size: 1.75em}
    25%  { color: #6A9FFF; font-size: 2em}
    50%  { color: #B4CEFF; font-size: 1em}
    75%  { color: #FFFFFF; font-size: 1.25em}
    100% { color: #005AFF; font-size: 1.5em}
  }

  @keyframes circle-light-reverse-2 {
    0%   { color: #005AFF; font-size: 1.5em}
    25%  { color: #FFFFFF; font-size: 1.25em}
    50%  { color: #B4CEFF; font-size: 1em}
    75%  { color: #6A9FFF; font-size: 2em}
    100% { color: #3079FF; font-size: 1.75em}
  }

  @keyframes circle-light-3 {
    0%   { color: #005AFF; font-size: 1.5em}
    25%  { color: #3079FF; font-size: 1.75em}
    50%  { color: #6A9FFF; font-size: 2em}
    75%  { color: #B4CEFF; font-size: 1em}
    100% { color: #FFFFFF; font-size: 1.25em}
  }

  @keyframes circle-light-reverse-3 {
    0%   { color: #FFFFFF; font-size: 1.25em}
    25%  { color: #B4CEFF; font-size: 1.1em}
    50%  { color: #6A9FFF; font-size: 2em}
    75%  { color: #3079FF; font-size: 1.75em}
    100% { color: #005AFF; font-size: 1.5em}
  }

</style>

<div class="app-incomingcall">

  <div class="circle-lights">
    <div class="circle-light"><i class="fas fa-circle"></i></div>
    <div class="circle-light"><i class="fas fa-circle"></i></div>
    <div class="circle-light"><i class="fas fa-circle"></i></div>
  </div>

  <div class="contact-label">{contactLabel}</div>

  <div class="call-button end-call" on:mouseup={e => denyCall()}>
    <i class="fas fa-phone-slash fa-2x"></i>
  </div>

  <div class="call-button accept-call" on:mouseup={e => acceptCall()}>
    <i class="fas fa-phone fa-2x"></i>
  </div>

</div>